#ifndef SOCK_H
#define SOCK_H

#include <netinet/in.h>

#include "sslut.h"

#define BANNER_TIMEOUT		4	/* timeout when retrieving banner */

typedef struct st_conxion
{
	struct in_addr          dip;
	unsigned short		sport;
	unsigned short		dport;
	int			sock;
	SSL			*ssl_sock;
	SSL_CTX			*ssl_ctx;

} conxion;


unsigned long int	resolve_host_name (char *);
int			connect_tcp (struct in_addr *, unsigned short, unsigned short);
int			set_reuseaddr (int, int);
int			listen_sock (unsigned short int);
int			bind_sock (unsigned short int);
int			wait_for_connect (int);
int			multiplex_loop (int, int, int);
int			data_available (int, int);
int			set_nonblocking_mode (int);
int			unset_nonblocking_mode (int, int);
int			read_banner (int);

#endif
