#ifndef SSLUT_H
#define SSLUT_H

#include "openssl/ssl.h"

#define SSL_HANDSHAKE_TIMEOUT	5   /* 5 seconds timeout for handshake is supposedly enough */

int     ssl_init_connect (SSL **, SSL_CTX **);
int	ssl_init_accept (SSL_CTX **, char *);
int     ssl_connect_ip (struct in_addr *, unsigned short, unsigned short, SSL **, SSL_CTX **);
int     ssl_wait_for_connection (int, SSL **, SSL_CTX *);
int     ssl_check_retcode (SSL *, int);
int     ssl_handshake_timeout (SSL *, int, int);
int     ssl_write (SSL*, char *, unsigned int);
int     ssl_writes (SSL*, char *);
int     ssl_close_connection (SSL *, SSL_CTX *);
int     ssl_close_all (int, SSL *, SSL_CTX *);
int     ssl_multiplex_loop (SSL *, int, int, int);
void    ssl_print_cipher (SSL *);
int     ssl_read_banner (SSL *, int); 
#endif

